#include "header.h"

int main()
{
	srand(time(NULL));//Semilla para los aleatorios

	//Inicialización del Jugador individual
	Jugador J1;
		J1.nombre="";
		J1.puntuacion=0;
		for(int i=0;i<numPru;i++)
		{J1.clasificacion[i]=0;}
		for(int i=0;i<numLog;i++)
		{J1.logros[i]=false;}

	//Inicialización del vector de Ranking
	Jugador Ranking[numRank];
	for(int i=0;i<numRank;i++)
	{
		Ranking[i].nombre="";
		Ranking[i].puntuacion=0;
	}
	int nR=0;

	//Inicialización del vector de Perfiles
	Jugador Perfiles[numPerf];
	for(int i=0;i<numPerf;i++)
	{
		Perfiles[i].nombre="";
		for(int c=0;c<numPru;c++)
		{Perfiles[i].clasificacion[c]=0;}
		for(int c=0;c<numLog;c++)
		{Perfiles[i].logros[c]=0;}
	}
	int nP=0;

	//Otras variables
	int lvl=0;
	char confirm='\0';
	int opcion=0;
	char back='b';

	presentacion();

	introducirNombre(J1,confirm);

	cargarPerfiles(Perfiles,nP,numPerf,numPru);

	//Si el perfil existe, se carga y se borra para volver a insertarse luego, actualizado
	for(int i=0;i<nP;i++)
	{
		if(J1.nombre==Perfiles[i].nombre)
		{
			J1=Perfiles[i];
			for(int c=i;c<nP;c++)
			{
				Perfiles[c]=Perfiles[c+1];
			}
			nP--;
	}	}

	SelecDif(lvl);

	do
	{
		//Reset del Ranking
		for(int i=0;i<numRank;i++)
		{
			Ranking[i].nombre="";
			Ranking[i].puntuacion=0;
		}
		nR=0;

		MenuPrincipal(opcion);

		switch(opcion)
		{
		case 1:
			Desafio(Ranking,nR,J1,lvl,30,back);
			break;
		case 2:
			Desafio(Ranking,nR,J1,lvl,60,back);
			break;
		case 3:
			Supervivencia(Ranking,nR,J1,lvl,back);
			break;
		case 4:
			mostrarPerfil(J1,back);
			break;
		case 5:
			mostrarRanking(Ranking,nR,back);
			break;
		case 6:
			mostrarLogros(J1.logros,back);
			break;
		case 7:
			SelecDif(lvl);
			break;
		}
	}while(opcion!=8);

	Perfiles[nP]=J1; nP++;
	guardarPerfiles(Perfiles,nP,numPerf,numPru);

	system("clear");
	cout << "\nBRAIN SMASH, hecho por Igseth para Bit Heroes";
	cout << "\n  THANK YOU SO MUCH FOR PLAYING MY GAME ^^\n\n";

	return 0;
}

void presentacion()
{
	char start='\0';
	do
	{
		system("clear");
		cout << "              IGSETH PRESENTS\n";
		cout << endl;
		sleep(3);
		cout << " _______   _______   _______   _______   _       _ \n";
		cout << "|  ___  | |  ___  | |  ___  | |__   __| | |_    | |\n";
		cout << "| |___| | | |___| | | |___| |    | |    |  _|_  | |\n";
		cout << "|  ___  | |  _   _| |  ___  |    | |    | | |_|_| |\n";
		cout << "| |___| | | | |_|_  | |   | |  __| |__  | |   |_  |\n";
		cout << "|_______| |_|   |_| |_|   |_| |_______| |_|     |_|\n";
		cout << endl;
		cout << " _______   _       _   _______   _______   _     _ \n";
		cout << "|  _____| | |_   _| | |  ___  | |  _____| | |   | |\n";
		cout << "| |_____  |  _|_|_  | | |___| | | |_____  | |___| |\n";
		cout << "|_____  | | | |_| | | |  ___  | |_____  | |  ___  |\n";
		cout << " _____| | | |     | | | |   | |  _____| | | |   | |\n";
		cout << "|_______| |_|     |_| |_|   |_| |_______| |_|   |_|\n";
		cout << endl;
		cout << "              INTRODUCE S PARA EMPEZAR             \n";
		cout << "                        ";
		cin >> start;
	}while(start!='s' && start !='S');
}

void introducirNombre(Jugador &J1,char confirm)//Funciona
{
	do
	{
		system("clear");

		cin.ignore();
		cout << "----- Introduce tu nombre de jugador -----\n";
		cout << "----- : ";
		getline(cin,J1.nombre);
		cout << "\n¿Quieres entrar como " << J1.nombre << "? [s/n]:";
		cin >> confirm;
	}while(confirm!='s' && confirm!='S');
}

void SelecDif(int &lvl)//Funciona
{
	system("clear");

	cout << "----- Elige el nivel de dificultad -----\n";
	cout << "-----          1.Fácil             -----\n";
	cout << "-----          2.Normal            -----\n";
	cout << "-----          3.Difícil           -----\n";
	cout << "-----          4.Pesadilla         -----\n";
	cout << "----------------------------------------\n";
	cout << "- Introduce una opción                 -\n";
	cout << "----- : ";
	cin >> lvl;
}

void MenuPrincipal(int &opcion)//Funciona
{
	system("clear");

	cout << "----- MENU PRINCIPAL -----\n";
	cout << "-   1.Desafío de 30 seg  -\n";
	cout << "-   2.Desafío de 1 min   -\n";
	cout << "-   3.Modo supervivencia -\n";
	cout << "-   4.Perfil             -\n";
	cout << "-   5.Ranking            -\n";
	cout << "-   6.Logros             -\n";
	cout << "-   7.Dificultad         -\n";
	cout << "-   8.Salir              -\n";
	cout << "--------------------------\n";
	cout << "- Introduce una opción   -\n";
	cout << "----- : ";
	cin >> opcion;
}

void Desafio(Jugador Ranking[],int &nR,Jugador &J1,int lvl,int tlim,char back)//Funciona
{
	system("clear");

	int n=0;
	int m=0;
	int ciphn=10;
	int ciphm=10;
	int op=0;
	int level=0;
	int res=0;
	int answer=0;
	string nomrank="";
	time_t tiempo = time(NULL);
	bool found=false;

	cout << "¿ESTÁS PREPARADO?\n";
	sleep(2);
	system("clear");
	cout << "¡¡ADELANTE!!\n";
	sleep(1);
	system("clear");

	while(time(NULL)-tiempo<=tlim)
	{
		n = rand() % ciphn;
		m = rand() % ciphm;
		op = rand() % lvl;

		switch(op)
		{
		case 0:
			cout << n << " + " << m << " = ";
			res=n+m;
			break;
		case 1:
			cout << n << " - " << m << " = ";
			res=n-m;
			break;
		case 2:
			cout << n << " * " << m << " = ";
			res=n*m;
			break;
		case 3:
			if(m==0)
			{
				cout << n << " / 1 = ";
				res=n;
			}
			else
			{
				cout << n << " / " << m << " = ";
				res=n/m;
			}
			break;
		}

		cin >> answer;

		if(res==answer && time(NULL)-tiempo<=tlim)
		{
			cout << "V\n";
			J1.puntuacion+=(ciphn+ciphm)*pow(2,lvl);
			level++;
			if((level%5)==0)
			{ciphn*=10;}
			if((level%10)==0)
			{ciphm*=10; ciphn/=10;}
		}
		else
		{
			cout << "X\n";
			if(level>1)
			{
				level--;
				ciphn/=10;
				ciphm=ciphn;
			}
		}
	}
	cout << "\nTu puntuación ha sido de " << J1.puntuacion << ". ¡Comprueba tu posición en el ránking!\n\n";

	if(J1.puntuacion>2000 && !J1.logros[0])
	{J1.logros[0]=true; cout << "Logro Desbloqueado: BUENO, ESTO ES FÁCIL\n";}

	if(J1.puntuacion>4500 && !J1.logros[1])
	{J1.logros[1]=true; cout << "Logro Desbloqueado: AHORA UN POCO MÁS\n";}

	if(J1.puntuacion>15000 && !J1.logros[2])
	{J1.logros[2]=true; cout << "Logro Desbloqueado: LA COSA SE COMPLICA\n";}

	if(J1.puntuacion>100000 && !J1.logros[4])
	{J1.logros[4]=true; cout << "Logro Desbloqueado: GOD LIKE\n";}

	switch(tlim)
	{
	case 30:
		nomrank="rank30.txt";
		break;
	case 60:
		nomrank="rank60.txt";
		break;
	}

	cargarRanking(Ranking,nR,nomrank);

	insertarJugador(Ranking,J1,nR);

	for(int i=1;i<=nR;i++)
	{
		switch(tlim)
		{
		case 30:
			if(J1.nombre==Ranking[i-1].nombre && !found)
			{J1.clasificacion[0]=i; found=true;}
			break;
		case 60:
			if(J1.nombre==Ranking[i-1].nombre && !found)
			{J1.clasificacion[1]=i; found=true;}
			break;
	}	}

	guardarRanking(Ranking,nR,nomrank);

	cout << "\nIntroduce b cuando quieras volver al menú principal: ";
	cin >> back;
}

void Supervivencia(Jugador Ranking[],int &nR,Jugador &J1,int lvl,char back)//Funciona
{
	system("clear");

	int n=0;
	int m=0;
	int ciphn=10;
	int ciphm=10;
	int op=0;
	int level=0;
	int res=0;
	int answer=0;
	string difrank="";
	time_t tiempo = time(NULL);
	bool found=false;

	cout << "¿ESTÁS PREPARADO?\n";
	sleep(2);
	system("clear");
	cout << "¡¡ADELANTE!!\n";
	sleep(1);
	system("clear");

	do
	{
		n = rand() % ciphn;
		m = rand() % ciphm;
		op = rand() % lvl;

		switch(op)
		{
		case 0:
			cout << n << " + " << m << " = ";
			res=n+m;
			break;
		case 1:
			cout << n << " - " << m << " = ";
			res=n-m;
			break;
		case 2:
			cout << n << " * " << m << " = ";
			res=n*m;
			break;
		case 3:
			if(m==0)
			{
				cout << n << " / 1 = ";
				res=n;
			}
			else
			{
				cout << n << " / " << m << " = ";
				res=n/m;
			}
			break;
		}
		cin >> answer;

		if(res==answer)
		{
			cout << "V\n";
			J1.puntuacion+=(ciphn+ciphm+pow(10,lvl));
			level++;
			if((level%5)==0)
			{ciphn*=10;}
			if((level%10)==0)
			{ciphm*=10; ciphn/=10;}
		}
		else
		{
			J1.puntuacion/=time(NULL)-tiempo;
			cout << "X\n";
		}
	}while(res==answer);

	if(J1.puntuacion>25 && !J1.logros[3])
	{J1.logros[3]=true; cout << "Logro Desbloqueado: BEAR GRYLLS\n";}

	cout << "\nTu puntuación ha sido de " << J1.puntuacion << ". ¡Comprueba tu posición en el ránking!\n";

	cargarRanking(Ranking,nR,"supervivencia.txt");
	insertarJugador(Ranking,J1,nR);

	for(int i=1;i<=nR;i++)
	{
		if(J1.nombre==Ranking[i-1].nombre && !found)
		{J1.clasificacion[2]=i; found=true;}
	}

	guardarRanking(Ranking,nR,"supervivencia.txt");

	cout << "\nIntroduce b cuando quieras volver al menú principal: ";
	cin >> back;
}

void cargarPerfiles(Jugador Perfiles[],int &nP,int numPerf,int numPru)//Funciona
{
	ifstream file;
	string lectura="";

	file.open("perfiles.txt",ios::in);
	if (file.is_open())
	{
		getline(file,lectura);
		if(!file.eof())
		{
			for(nP=0;nP<numPerf && !lectura.empty();nP++)
			{
				Perfiles[nP].nombre=lectura;
				for(int i=0;i<numPru;i++)
				{
					getline(file,lectura);
					Perfiles[nP].clasificacion[i]=atoi(lectura.c_str());
				}
				for(int i=0;i<numLog;i++)
				{
					getline(file,lectura);
					Perfiles[nP].logros[i]=(bool)atoi(lectura.c_str());
				}
				getline(file,lectura);
			}
		}
		file.close();
	}
	else
	{cout << "Los perfiles no se han podido cargar" << endl;}
}

void guardarPerfiles(Jugador Perfiles[],int &nP,int numPerf,int numPru)//Funciona
{
	ofstream file;

	file.open("perfiles.txt",ios::out);
	if (file.is_open())
	{
		for(int i=0;i<nP;i++)
		{
			file << Perfiles[i].nombre << endl;
			for(int c=0;c<numPru;c++)
			{file << Perfiles[i].clasificacion[c] << endl;}
			for(int c=0;c<numLog;c++)
			{file << Perfiles[i].logros[c] << endl;}
		}
		file.close();
	}
	else
	{cout << "Los perfiles no se han podido guardar" << endl;}
}

void mostrarPerfil(Jugador J1,char back)//Funciona
{
	system("clear");

	cout << "----- PERFIL -----\n";
	cout << "- Nombre: " << J1.nombre << " -" << endl;
	cout << "- Posición en el Ranking del Desafío de 30 seg - " << J1.clasificacion[0] << endl;
	cout << "- Posición en el Ranking del Desafío de 1 min - " << J1.clasificacion[1] << endl;
	cout << "- Posición en el Ranking del Modo supervivencia - " << J1.clasificacion[2] << endl;
	cout << "- Logros desbloqueados -\n\n";
	mostrarLogros(J1.logros,back);
}

void mostrarLogros(bool logros[],char back)//Funciona
{
	if(logros[0])
	{
		cout << "- V - BUENO, ESTO ES BASTANTE FÁCIL -\n";
		cout << "-------------------------------------\n";
		cout << "- Has conseguido una puntuación de 2000 -\n\n";
	}
	else
	{
		cout << "- X - BUENO, ESTO ES BASTANTE FÁCIL -\n";
		cout << "-------------------------------------\n";
		cout << "- Consigue una puntuación de 2000 en Desafío -\n\n";
	}
	if(logros[1])
	{
		cout << "- V - AHORA UN POCO MÁS -\n";
		cout << "-------------------------\n";
		cout << "- Has conseguido una puntuación de 4500 -\n\n";
	}
	else
	{
		cout << "- X - AHORA UN POCO MÁS -\n";
		cout << "-------------------------\n";
		cout << "- Consigue una puntuación de 4500 en Desafío -\n\n";
	}
	if(logros[2])
	{
		cout << "- V - LA COSA SE COMPLICA -\n";
		cout << "---------------------------\n";
		cout << "- Has conseguido una puntuación de 15000 -\n\n";
	}
	else
	{
		cout << "- X - LA COSA SE COMPLICA -\n";
		cout << "---------------------------\n";
		cout << "- Consigue una puntuación de 15000 en Desafío -\n\n";
	}
	if(logros[3])
	{
		cout << "- V - BEAR GRYLLS -\n";
		cout << "-------------------\n";
		cout << "- Eres un maestro de la supervivencia. Better drink your own piss -\n\n";
	}
	else
	{
		cout << "- X - BEAR GRYLLS -\n";
		cout << "-------------------\n";
		cout << "- Consigue sacar una puntuación de más de 25 en Modo Supervivencia -\n\n";
	}
	if(logros[4])
	{
		cout << "- V - GOD LIKE -\n";
		cout << "----------------\n";
		cout << "- Como cierto profesor de física, has conseguido más de 100000 puntos en Desafío -\n\n";
	}
	else
	{
		cout << "- X - GOD LIKE -\n";
		cout << "----------------\n";
		cout << "- Sólo para verdaderos Elegidos. Consigue más de 100000 puntos en Desafío -\n\n";
	}
	cout << "\nIntroduce b cuando quieras volver al menú principal: ";
	cin >> back;
}

void cargarRanking(Jugador Ranking[],int &nR,string nomrank)//Funciona
{
	ifstream file;
	string lectura="";
	Jugador temp;
		temp.nombre="";
		temp.puntuacion=0;

	file.open(nomrank.c_str(),ios::in);
	if (file.is_open())
	{
		getline(file,lectura);
		if(!file.eof())
		{
			do
			{
				temp.nombre=lectura;
				getline(file,lectura);
				temp.puntuacion=atoi(lectura.c_str());
				insertarJugador(Ranking,temp,nR);
				getline(file,lectura);
			}while(!file.eof());
		}
		file.close();
	}
	else
	{cout << "El Ranking no se ha podido cargar" << endl;}
}

void mostrarRanking(Jugador Ranking[], int nR,char back)//Funciona
{
	int oprank=0;
	system("clear");

	cout << "- ¿Qué Ranking quieres ver? -\n";
	cout << "-    1.Desafío de 30 seg    -\n";
	cout << "-    2.Desafío de 1 min     -\n";
	cout << "-    3.Modo supervivencia   -\n";
	cout << "-----------------------------\n";
	cout << "- Introduce una opción      -\n";
	cout << "----- : ";
	cin >> oprank;

	switch(oprank)
	{
	case 1:
		cargarRanking(Ranking,nR,"rank30.txt");
		break;
	case 2:
		cargarRanking(Ranking,nR,"rank60.txt");
		break;
	case 3:
		cargarRanking(Ranking,nR,"supervivencia.txt");
		break;
	}

	system("clear");

	cout << "----- RANKING -----\n";
	for(int i=0;i<nR;i++)
	{
		cout << "- " << Ranking[i].nombre << " : " << Ranking[i].puntuacion << endl;
	}
	cout << "-------------------\n";

	cout << "\nIntroduce b cuando quieras volver al menú principal: ";
	cin >> back;
}

void insertarJugador(Jugador Ranking[],Jugador J1,int &nR)//Funciona
{
	bool cond=false;

	for(int i=nR; i>=0; i--)
	{
		if(!cond)
		{
			if(nR==0 || i==0)
			{
				Ranking[0].nombre=J1.nombre;
				Ranking[0].puntuacion=J1.puntuacion;
				nR++;
				cond=true;
			}
			else if(J1.puntuacion<=Ranking[i-1].puntuacion)
			{
				Ranking[i].nombre=J1.nombre;
				Ranking[i].puntuacion=J1.puntuacion;
				nR++;
				cond=true;
			}
			else
			{
				Ranking[i]=Ranking[i-1];
}	}	}	}

void guardarRanking(Jugador Ranking[],int nR,string nomrank)//Funciona
{
	ofstream file;

	file.open(nomrank.c_str(),ios::out);
	if (file.is_open())
	{
		file.clear();
		for(int i=0;i<nR;i++)
		{
			file << Ranking[i].nombre << endl;
			file << Ranking[i].puntuacion << endl;
		}
		file.close();
	}
	else
	{cout << "El Ranking no se ha podido cargar" << endl;}
}

